MKTEMP(1) | General Commands Manual | MKTEMP(1)

# NAME

`mktemp` — make temporary file name (unique)

# SYNOPSIS

`mktemp` | [`-dqu`] [`-p` tmpdir] {`-t` prefix | template ...}

# DESCRIPTION

The `mktemp` utility is provided to allow shell scripts to safely use temporary files. It creates temporary files or directories using unique names, and prints the names.

The name of each temporary file or directory is derived from a template that includes several trailing ‘`X`’ characters, such as /tmp/prefix.XXXX. The trailing ‘`X`’ characters in the template are replaced with a unique letter and number combination. Any ‘`X`’ characters other than at the end of the template are taken literally. The number of unique file names `mktemp` can return depends on the number of trailing ‘`Xs`’ in the template; six ‘`Xs`’ will result in `mktemp` testing roughly 62 ** 6 (56800235584) combinations.

The templates used to create the unique names are derived from the `-t` prefix option, or the template arguments, possibly modified by other options. Any number of temporary files or directories may be created in a single invocation using multiple template arguments. It is possible to specify both a `-t` prefix option and one or more template arguments, but this is not usually done.

If neither a `-t` prefix option, nor any template arguments are specified, then the default is equivalent to `-t` `mktemp`.

If `mktemp` can successfully generate a unique file name, the file is created with mode 0600 (unless the `-u` flag is given) and the filename is printed to standard output.

# OPTIONS

The available options are as follows:

`-d`
  Make a directory instead of a file.
`-p` tmpdir
  Specifies a directory in which temporary files should be created. If this option is specified, then it applies to all temporary files, including those created as a result of a `-t` prefix option, and those created as a result of a template argument.

  If the `-p` tmpdir option is not specified, then temporary files created as a result of a `-t` prefix option will use a default temporary directory (as described under the `-t` option), but temporary files created as a result of a template argument will not use a default temporary directory (so they will be created relative to the current working directory, if the template does not begin with ‘`/`’).

`-t` prefix
  Generate a template using an appropriate directory name, followed by the supplied prefix, followed by ‘`.XXXXXXXX`’. Any ‘`X`’ characters in the supplied prefix are taken literally, but the trailing ‘`X`’ characters in the appended ‘`.XXXXXXXX`’ are replaced by unique values.

  The directory name used for the template generated by the `-t` prefix option is taken from the `-p` tmpdir option, or from the `TMPDIR` environment variable, or /tmp as a default.

  If one or more template arguments are used in addition to the `-t` prefix option, then the prefix does not apply to the template arguments.

`-q`
  Fail silently if an error occurs. This is useful if a script does not want error output to go to standard error.
`-u`
  Operate in “unsafe” mode. The temp file will be unlinked before `mktemp` exits. This is slightly better than mktemp(3) but still introduces a race condition. Use of this option is not encouraged.

# NOTES

`mktemp` takes care to create the files or directories in a way that is safe from race conditions (provided the `-u` option is not used).

Traditionally, without `mktemp`, many shell scripts created temporary files using the name of the program with the pid as a suffix. This kind of naming scheme is predictable and creates a race condition that allows an attacker to subvert the program by creating a different file, directory, or symbolic link under the same name. A safer, though still inferior, approach is to make a temporary directory using the same naming scheme While this does allow one to guarantee that a temporary file will not be subverted, it still allows a simple denial of service attack. For these reasons it is recommended that `mktemp` be used instead of simpler schemes.

Care should be taken to ensure that it is appropriate to use an environment variable potentially supplied by the user.

# EXIT STATUS

The `mktemp` utility exits with a value of 0 on success, and 1 on any failure.

# EXAMPLES

The following sh(1) fragment illustrates a simple use of `mktemp` where the script should quit if it cannot get a safe temporary file.

    TMPFILE=`mktemp /tmp/${0##*/}.XXXXXX` || exit 1
    echo "program output" >> $TMPFILE

To allow the use of $TMPDIR:

    TMPFILE=`mktemp -t ${0##*/}` || exit 1
    echo "program output" >> $TMPFILE

In this case, we want the script to catch the error itself.

    TMPFILE=`mktemp -q /tmp/${0##*/}.XXXXXX`
    if [ $? -ne 0 ]; then
    	echo "$0: Can't create temp file, exiting..."
    	exit 1
    fi

# SEE ALSO

mkdtemp(3), mkstemp(3), mktemp(3), environ(7)

# HISTORY

The `mktemp` utility appeared in NetBSD 1.5. It was imported from FreeBSD, and the idea and the manual page were taken from OpenBSD.

July 25, 2021 | NetBSD 11.99